/*
This example needs inlining at least 2
*/

function Main () {
	var c1;
	var c2;
	var c3;
	
	c1 = new IntegerCell(1);
	c2 = new IntegerCell(2);
	c3 = new IntegerCell(3);
	
	assert(c1.value == 1);
	assert(c2.value == 2);
	assert(c3.value == 3);
	
	c1.setValue(4);
	c2.setValue(5);
	c3.setValue(6);

	var r1;
	var r2;
	var r3;
	r1 = c1.getValue();
	r2 = c2.getValue();
	r3 = c3.getValue();
	
	assert( r1 == 4);
	assert( r2 == 5);
	assert( r3 == 6);
	
	c1 = new IntegerReCell(11);
	c2 = new IntegerReCell(12);
	c3 = new IntegerReCell(13);
	
	assert(c1.value == 11);
	assert(c2.value == 12);
	assert(c3.value == 13);
	
	c1.setValue(14);
	c2.setValue(15);
	c3.setValue(16);
	
	assert( c1.value == 14);
	assert( c2.value == 15);
	assert( c3.value == 16);
	
	assert( c1.lastValue == 11);
	assert( c2.lastValue == 12);
	assert( c3.lastValue == 13);
	
	c1 = new IntegerDCell(41);
	c2 = new IntegerDCell(42);
	c3 = new IntegerDCell(43);
	
	assert(c1.value == 41);
	assert(c2.value == 42);
	assert(c3.value == 43);
	
	c1.setValue(10);
	c2.setValue(25);
	c3.setValue(30);
	
	assert( c1.value == 20);
	assert( c2.value == 50);
	assert( c3.value == 60);
	
	assert( c1.lastValue == 41);
	assert( c2.lastValue == 42);
	assert( c3.lastValue == 43);
	
}


/*
   IntegerCell class
*/
function IntegerCell (a_value) {
	this.value = a_value;
}

IntegerCell.prototype.value = 0;

IntegerCell.prototype.setValue = function (a_value) {
	this.value = a_value;
};

IntegerCell.prototype.getValue = function () {
	return this.value;
};


/*
   IntegerReCell class inherits IntegerCell
*/
function IntegerReCell (a_value) {
	this.lastValue = this.value;
	this.value = a_value;
}

IntegerReCell.prototype.value = 0;
IntegerReCell.prototype.lastValue = 0;

IntegerReCell.prototype.setValue = function (a_value) {
	this.lastValue = this.value;
	this.value = a_value;
};

IntegerReCell.prototype.getValue = function () {
	return this.value;
};


/*
   IntegerDCell class inherits IntegerCell
*/
function IntegerDCell (a_value) {
	this.lastValue = this.value;
	this.value = a_value;
}

IntegerDCell.prototype.value = 0;
IntegerDCell.prototype.lastValue = 0;

IntegerDCell.prototype.setValue = function (a_value) {
	this.lastValue = this.value;
	this.value = 2 * a_value;
};

IntegerDCell.prototype.getValue = function () {
	return this.value;
};
