/*
  Test of the example sequences modeling Arithmetic,
  Fibonacci, Integer, and Monotone sequences. 
  It needs inlining at least 2
*/

function Main () {
    var arith_seq;
    var fibo_seq;
    
    arith_seq = new ArithmeticSequence (3, 5);
    
    arith_seq.forth();
	arith_seq.forth();
	arith_seq.forth();

	assert(arith_seq.item == 18);
    
    fibo_seq = new FibonacciSequence();

	fibo_seq.forth();
	fibo_seq.forth();
	fibo_seq.forth();
	fibo_seq.forth();
	fibo_seq.forth();

	assert (fibo_seq.item == 8);
	
	var seq;

	seq = new ArithmeticSequence(3,5);
	seq.forth();
	seq.forth();
	seq.forth();

	assert( seq.item == 18)
}

/*
   IntegerSequence class
*/
function IntegerSequence () {
	this.item = 0;
}

IntegerSequence.prototype.item = 0;

IntegerSequence.prototype.forth = function () {
	this.item = 0; 
};



/*
   MonotoneSequence class
*/
function MonotoneSequence () {
	this.item = 0;
}

MonotoneSequence.prototype.item = 0;

MonotoneSequence.prototype.forth = function () {
	this.item = 0; 
};


/*
   FibonacciSequence class
*/
function FibonacciSequence () {
	this.last_item = 0;
	this.item = 1;
}

FibonacciSequence.prototype.item = 0;

FibonacciSequence.prototype.last_item = 0;


FibonacciSequence.prototype.forth = function () {
	var l_temp;
	l_temp = this.item;
	this.item = this.item + this.last_item;
	this.last_item = l_temp;
};


/*
   ArithmeticSequence class
*/
function ArithmeticSequence (a_start,a_difference) {
	this.item = a_start;
	this.difference = a_difference;
}

ArithmeticSequence.prototype.item = 0;
ArithmeticSequence.prototype.difference = 0;


ArithmeticSequence.prototype.forth = function () {
	this.item = this.item + this.difference;
};